﻿package Type
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.KeyboardEvent;
	import flash.events.Event;
	
	
	public class TypeMgr extends Sprite
	{
		var wordMgr:Word;	
		var _parent:Sprite;
		
		var activeWordAry:Array = new Array();
		var lockOnStrIndex:uint = 0;
		var lsLockOn:Boolean 	= false;
		var lockOnImg:MovieClip;
	
		
		/**
		 * コンストラクタ
		 * @param	root	
		 */
		public function TypeMgr(root:Sprite):void
		{
			lockOnImg = new LockOnImg();
			lockOnImg.x = lockOnImg.y = -100;
			addChild(lockOnImg);
			
			wordMgr = new Word("WORDS.xml");
			this._parent = root;
			_parent.stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			this.addEventListener(Event.ENTER_FRAME, update);
		}
		
		
		/**
		 * フレーム関数
		 * @param	e
		 */
		public function update(e:Event):void
		{
			if (activeWordAry.length > 10) return;
			
			if (Math.floor(Math.random() * 12) == 0)
			{
				setWord();
			}
		}

		/**
		 * キーが押されたときの処理
		 * @param	e
		 */
		public function keyDownHandler(e:KeyboardEvent):void
		{
			//trace(e.keyCode);
			var charCode = e.charCode;
			
			
			//入力中の単語がある
			if (lsLockOn == true) {
				
				checkKey(lockOnStrIndex, charCode);
			}
			
			//入力中でない
			else {
				var i:uint;
				
				//押されたキーに対応する先頭文字を探す
				for (i=0; i<activeWordAry.length; i++) {
					if (activeWordAry[i] == null) continue;
					
					if (checkKey(i, charCode) == true) {
						setLockOn(i);
						break;
					}
					
				}
			}
		}
		
		
		/**
		 * 入力キーが正しいかどうか調べる
		 * @param	i			調べる配列番号
		 * @param	charCode	入力されたキーコード
		 * @return	押されたキーが正しいかどうか
		 */
		function checkKey(i:uint, charCode:Number):Boolean
		{
			var tmpStr:String = activeWordAry[i].inputTF.text;
			
			var tmpCodeUp:Number = tmpStr.toUpperCase().charCodeAt(0);
			var tmpCodeLow:Number= tmpStr.toLowerCase().charCodeAt(0);

			//発見
			if ((charCode == tmpCodeUp) 
			||  (charCode == tmpCodeLow) ) {
				//ロックオン
				lockOnStrIndex = i;
				lsLockOn = true;

				activeWordAry[i].inputTF.text = tmpStr.substr(1);
				
				
				//文字入力完了
				if (activeWordAry[i].inputTF.text.length == 0) {
					removeWordFrame(i);
					lsLockOn = false;		
					
				}
				return true;
			}
			
			return false;
		}		
		
		
		/**
		 * 単語を消す
		 * @param	index
		 */
		function removeWordFrame(index:uint) {
			
			removeChild(activeWordAry[index]);
			activeWordAry[index] = null;
			activeWordAry.splice(index, 1);
			
			outLockOn();
		}
		
		
		/**
		 * ロックオンを表示
		 * @param	index	ロックオンする単語の番号
		 */
		function setLockOn(index:uint):void
		{
			lockOnImg.x = activeWordAry[index].x;
			lockOnImg.y = activeWordAry[index].y;
		}
		
		/**
		 * ロックオン表示を消す
		 */
		function outLockOn():void
		{
			lockOnImg.x = lockOnImg.y = -100;
		}
		

		/**
		 * 単語をセット
		 */
		public function setWord():void
		{
			var r:uint, i:uint, cnt:uint;
			var tmpCode:Number;
			var tmpCodeUp:Number, tmpCodeLow:Number;
			var tmpStr:String;
			var randomStr:String;
			
			//アクティブな単語の頭文字を調べて一致しない単語を追加する
			while (true)
			{
				r = Math.floor(Math.random() * wordMgr.length);
				
				randomStr = wordMgr.getEngWord(r);
				tmpCode = randomStr.charCodeAt(0);
				
				//表示中の単語の頭文字と比較
				for (i=0; i<activeWordAry.length; i++) {
					
					//入力中の単語は無視
					if (lsLockOn && i == lockOnStrIndex) continue;
					if (activeWordAry[i] == null) continue;
					
					tmpStr = activeWordAry[i].inputTF.text;
					tmpCodeUp  = tmpStr.toUpperCase().charCodeAt(0);
					tmpCodeLow = tmpStr.toLowerCase().charCodeAt(0);
					
					
					//頭文字が一致 = ダメな単語だった。
					if ((tmpCode == tmpCodeUp)
					||  (tmpCode == tmpCodeLow) ) {
						break;
					}
					
				}
				
				//追加可能な単語を発見
				if (i == activeWordAry.length) {
					break;
				}
				
				//無限ループ回避 (単語発見失敗)	
				cnt++;
				if (cnt > 100) {
					trace("単語発見失敗");
					return;
				}
			}
			
			//単語を追加する。
			var frame:MovieClip = new WordFrame();
			var inputStr:String;
			
			inputStr 		= randomStr;
			
			frame.inputTF.text = inputStr;
			frame.inputJapTF.text = wordMgr.getJapWord(r);
			addChild(frame);
			
			//表示する位置を決定
			cnt = 0;
			while (true) {
				var lsHit:Boolean = false;
				
				frame.x = frame.width /2 + Math.random() * (_parent.stage.stageWidth - frame.width);
				frame.y = frame.height/2 + Math.random() * (_parent.stage.stageHeight- frame.height);
			
				for (i=0; i<activeWordAry.length; i++) {
					if (frame.hitTestObject(activeWordAry[i]) )
					{
						lsHit = true;
						break;
					}
				}
				
				if (lsHit == false) {
					break;
				}
				
				cnt++;
				if (cnt > 100) {
					removeChild(frame);
					frame = null;
					return;
				}
			}
			
			
			
			activeWordAry.push(frame);
		}

	}
}