﻿package Type
{
	/**
	 * 出題単語を管理するクラス
	 */
	public class Word
	{
		var words:Array = new Array();
		var xmlLoader:XMLLoader;
		
		public var length:uint;
		
		
		/**
		 * コンストラクタ
		 * @param	xmlURL	単語の入ったXMLのURL
		 */
		public function Word(xmlURL:String):void
		{
			xmlLoader = new XMLLoader(xmlURL);
			xmlLoader.load(onLoadXML);			
		}
		
		
		/**
		 * XML読み込み完了時にxmlLoaderに実行される関数
		 * @param	xml		読み込んだXML
		 */
		public function onLoadXML(xml:XML):void
		{
			var tmpObj:Object;
			
			for each(var word:XML in xml..w)
			{
				tmpObj = new Object();
				tmpObj.jap = word.@j;
				tmpObj.eng = word.@e;
				
				words.push(tmpObj);
				
				//trace(tmpObj.jap, tmpObj.eng);
			}
			length = words.length;
		}
		
		
		/**
		 * 指定番号の単語(日本語)を返す
		 * @param	index	
		 * @return	日本語
		 */
		public function getJapWord(index:uint):String
		{
			if (index >= words.length) {
				trace("不正なインデックス ["+index+"] です" + this);
				return null;
			}
			
			return words[index].jap;
		}
		
		/**
		 * 指定番号の単語(ローマ字)を返す
		 * @param	index
		 * @return	ローマ字
		 */
		public function getEngWord(index:uint):String
		{
			if (index >= words.length) {
				trace("不正なインデックス ["+index+"] です" + this);
				return null;
			}
			
			return words[index].eng;
		}

	}
}