﻿package Type
{
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.events.Event;
	
	/**
	 * XMLを読み込むクラス
	 */
	public class XMLLoader
	{
		var xml:XML;
		var loader:URLLoader;
		var request:URLRequest;
		var url:String;
		
		var onLoadCallBack:Function;
		
		
		/**
		 * コンストラクタ
		 * @param	url	読み込むXMLのURL
		 */
		public function XMLLoader(url:String):void
		{
			XML.ignoreComments = false;
			XML.ignoreProcessingInstructions = false;

			this.url = url;
		}
		
		/**
		 * 読み込み開始
		 * @param	callBackFunc	読み込み完了時に実行する関数
		 */		
		public function load(callBackFunc:Function=null):void
		{
			loader = new URLLoader();
			request= new URLRequest(url);
			
			loader.addEventListener(Event.COMPLETE, onLoadComplete);
			onLoadCallBack = callBackFunc;
			loader.load(request);
		}
		
		
		function onLoadComplete(e:Event):void
		{
			xml = new XML(e.target.data);
		
			
			if (onLoadCallBack != null) {
				onLoadCallBack(xml);
			}
		}
		
	}
	
}